var moose = require("../../lib"), comb = require("comb");

exports.sql = "DROP TABLE IF EXISTS works;"
        + "DROP TABLE IF EXISTS company;"
        + "DROP TABLE IF EXISTS employee;"
        + "CREATE TABLE company ("
        + "company_name              VARCHAR(20) NOT NULL PRIMARY KEY,"
        + "city                      VARCHAR(20) NOT NULL"
        + ");"
        + "CREATE TABLE employee ("
        + " eid                       INT NOT NULL AUTO_INCREMENT,"
        + " firstname                 VARCHAR(20)  NOT NULL,"
        + " lastname                  VARCHAR(20)  NOT NULL,"
        + " midinitial                VARCHAR(1),"
        + " gender                    VARCHAR(1)   NOT NULL,"
        + " street                    VARCHAR(50)  NOT NULL,"
        + " city                      VARCHAR(20)  NOT NULL,"
        + " PRIMARY KEY (eid, firstname)"
        + " );"
        + " CREATE TABLE works ("
        + " eid                       INT NOT NULL,"
        + " lastname                  VARCHAR(20)  NOT NULL,"
        + " firstname                 VARCHAR(20)  NOT NULL,"
        + " midinitial                VARCHAR(1),"
        + " company_name              VARCHAR(20)  NOT NULL,"
        + " salary                    INT UNSIGNED NOT NULL,"
        + " flag                      boolean DEFAULT 1,"
        + " another_flag	          boolean  DEFAULT 0,"
        + " yet_another_flag          boolean DEFAULT 0,"
        + " FOREIGN KEY (eid) REFERENCES employee(eid),"
        + " FOREIGN KEY (company_name) REFERENCES company(company_name)"
        + " );"
        + "INSERT INTO company VALUES ('FIRST Bank',          'Omaha');"
        + "INSERT INTO company VALUES ('FDR',                 'Omaha');"
        + "INSERT INTO company VALUES ('Lincoln STAR',        'Lincoln');"
        + "INSERT INTO company VALUES ('Mutual OF Omaha',     'Omaha');"
        + "INSERT INTO company VALUES ('UNION Pacific', 'Omaha');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Anderson', 'Susan',   'L', 'F', '108th',   'Omaha');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Brady',    'Dan',     'L', 'M', 'P street', 'Lincoln');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Chen',     'Peter',   'K', 'M', '124th',    'Omaha');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Clemson',  'Ann',     'M', 'F', 'O',        'Lincoln');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Dale',     'Mary',    'K', 'F', '132th',    'Omaha');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Gill',     'Mary',    'L', 'F', 'P street', 'Lincoln');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Harrison', 'Susan',   'M', 'F', 'Old Mill', 'Omaha');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Jackson',  'Kim',     'A', 'F', '178th',    'Omaha');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Jason',    'Pat',     'M', 'M', '8th',      'C.Bluffs');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Kumar',    'Paul',    'T', 'M', 'Dodge',    'Omaha');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Orr',      'Susanne', 'S', 'F', 'Q',        'Omaha');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Peterson', 'Mike',    'E', 'M', 'Blondo',   'Omaha');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Powell',   'Tom',     'E', 'M', 'Broadway', 'C.Bluffs');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Quinn',    'Jacky',   'M', 'F', '168st',    'Omaha');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Rand',     'Pam',     'R', 'F', '13st',     'Omaha');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Schreck',  'Ann',     'P', 'F', '214st',    'Elkhorn');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Simon',    'Eric',    'K', 'M', '77th',     'Lincoln');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Smith',    'John',    'A', 'M', '8th',      'C.Bluffs');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Thomson',  'Ron',     'F', 'M', 'Farnam',   'Omaha');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Young',    'Don',     'R', 'F', 'Dodge',    'Omaha');"
        + "INSERT INTO employee   (lastname, firstname, midinitial, gender, street, city) VALUES ('Wong',     'Carole',  'S', 'F', 'Broadway', 'C.Bluffs');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary, flag, another_flag, yet_another_flag) VALUES(1, 'Anderson', 'Susan',   'L', 'Mutual OF Omaha', '48000', false, true, true);"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(2, 'Brady',    'Dan',     'L', 'FDR',             '42000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(3, 'Chen',     'Peter',   'K', 'FDR',             '53000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(4, 'Clemson',  'Ann',     'M', 'FIRST Bank',      '39000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(5, 'Dale',     'Mary',    'K', 'Mutual OF Omaha', '58000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(6, 'Gill',     'Mary',    'L', 'UNION Pacific',   '48700');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(7, 'Harrison', 'Susan',   'M', 'UNION Pacific',   '54320');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(8, 'Jackson',  'Kim',     'A', 'FDR',             '68000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(9, 'Jason',    'Pat',     'M', 'FDR',             '83000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(10, 'Kumar',    'Paul',    'T', 'FDR',            '44000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(11, 'Orr',      'Susanne', 'S', 'Lincoln STAR',   '32000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(12, 'Peterson', 'Mike',    'E', 'FIRST Bank',     '37000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(13, 'Powell',   'Tom',     'E', 'FIRST Bank',     '54000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(14, 'Quinn',    'Jacky',   'M', 'FIRST Bank',     '85000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(15, 'Rand',     'Pam',     'R', 'FDR',            '37000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(16, 'Schreck',  'Ann',     'P', 'FIRST Bank',     '36000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(17, 'Simon',    'Eric',    'K', 'Mutual OF Omaha','45000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(18, 'Smith',    'John',    'A', 'FDR',            '55000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(19, 'Thomson',  'Ron',     'F', 'FIRST Bank',     '39000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) VALUES(20, 'Young',    'Don',     'R', 'Mutual OF Omaha','27000');"
        + "INSERT INTO works (eid, lastname, firstname, midinitial, company_name, salary) values(21, 'Wong',     'Carole',  'S', 'FIRST Bank',     '44000');";

exports.dropModels = function() {
    var ret = new comb.Promise();
    moose.execute("DROP TABLE IF EXISTS works;"
        + "DROP TABLE IF EXISTS companyEmployee;"
        + "DROP TABLE IF EXISTS company;"
        + "DROP TABLE IF EXISTS employee;").then(comb.hitch(ret, "callback"), comb.hitch(ret, "errback"));
	moose.closeConnection();
    return ret;
};